#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Menu_Bar.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Box.H>
#include <stdio.h>
#include <stdlib.h>

// Small test for the Ctrl+N problem:

// 1. fltk-config --compile test.cxx
// 2. ./test
// 3. Type Ctrl+n: the buttons have the focus, and the global Ctrl+N 
//    shortcut never gets handled

void cb1(Fl_Widget* w, void*data) {
  printf("Got ctrl+n from menu\n");
}

void cb2(Fl_Widget* w, void*data) {
  printf("Got ctrl+a from menu\n");
}

int global_shortcuts(int event)
{
  if(event != FL_SHORTCUT)
    return 0;
  if(Fl::test_shortcut(FL_CTRL + 'n')){
    printf("Got ctrl+n from global_shortcuts()\n");
    return 1;
  }
  else if(Fl::test_shortcut(FL_CTRL + 'a')){
    printf("Got ctrl+a from global_shortcuts()\n");
    return 1;
  }
  return 0;
}

Fl_Menu_Item menutable[] = {
  {"&File", 0, 0, 0, FL_SUBMENU},
  {"&New...", FL_CTRL+'n', cb1},
    {0},
  {"&Help", 0, 0, 0, FL_SUBMENU},
    {"About...", FL_CTRL+'a', cb2},
    {0},
  {0}
};

int main(int argc, char **argv) {
  Fl::add_handler(global_shortcuts);

  Fl_Window window(200,200);
  Fl_Menu_Bar menubar(0,0,200,30);
  menubar.menu(menutable);
  //menubar.global(); 

  Fl_Button butt1(20,40,100,30,"Button1");
  Fl_Button butt2(30,80,100,30,"Button2");
  Fl_Button butt3(40,110,100,30,"Button3");

  window.end();
  window.position(100,100);
  window.show(argc, argv);

  //Fl_Window window2(100,100);
  //window2.end();
  //window2.position(350,100);
  //window2.show();

  return Fl::run();
}
